Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 1292)
@@ -91,6 +91,8 @@
   private long rootnodeid;
   private ElementNode rootNode = null;
   private TreeSet nodeRecordList = null;
+  //private static 
+  //ReplicationServerList serverList = new ReplicationServerList();
   
   /**
    * Constructor used to create a document and read the document information
@@ -412,6 +414,13 @@
         deleteXMLDocuments(docIdWithoutRev);
         ac = new AccessionNumber(accnum, "update");
       }
+      // local server has newer version, then notify the remote server
+      else if ( userSpecifyRev < revInDataBase && revInDataBase > 0)
+      {
+        throw new Exception("Local server: "+MetaCatUtil.getOption("server")+
+                 " has newer revision of doc: "+docIdWithoutRev+"."
+                  +revInDataBase+". Please notify it.");
+      }
       //other situation
       else
       {
@@ -442,13 +451,19 @@
       sql.append(sqlDateString).append(",");
       sql.append(sqlDateString).append(",");
       sql.append("'0')");
+      // Set auto commit fasle
+      dbconn.setAutoCommit(false);
       pstmt = dbconn.prepareStatement(sql.toString());
       pstmt.execute();
+      // Commit the insert
+      dbconn.commit();
       pstmt.close();
       //dbconn.close();
     } 
     finally 
     {
+      // Set DBConnection auto commit true
+      dbconn.setAutoCommit(true);
       pstmt.close();
       DBConnectionPool.returnDBConnection(dbconn, serialNumber);
     }    
@@ -456,8 +471,7 @@
   
  /**
    * This method will register a data file entry in xml_documents and save a
-   * data file input Stream into file system.. It is only used in force 
-   * replication
+   * data file input Stream into file system.. It is only used in replication
    *
    * @param  input, the input stream which contain the file content.
    * @param  , the input stream which contain the file content
@@ -467,15 +481,18 @@
    *               includes a revision number for this revision of the document 
    *               (e.g., knb.1.1)
    * @param user the user that owns the document
-   * @param serverCode the serverid from xml_replication on which this document
-   *        resides.
+   * @param docHomeServer, the home server of the docid
+   * @param notificationServer, the server to notify force replication info to 
+   *                            local metacat
    */
- public static void writeDataFile(InputStream input, String filePath, 
-                                  String docname, String doctype, String accnum, 
-                                  String user, String docHomeServer)
+ public static void writeDataFileInReplication(InputStream input, 
+                 String filePath, String docname, String doctype, String accnum, 
+                   String user, String docHomeServer, String notificationServer)
                      throws SQLException, AccessionNumberException, Exception
  {
-   int serverCode=-2;
+    int serverCode=-2;
+   
+    
     if (filePath==null||filePath.equals(""))
     {
       throw new 
@@ -486,45 +503,46 @@
       throw new Exception("Please specify the stored file name");
     }
     
-    //get server code for the home server
-    serverCode=getServerCode(docHomeServer);
-    //if the server is not in the xml replication table, insert it.
-    if (serverCode==-1)
-    {
-      insertServerIntoReplicationTable(docHomeServer);
-      //get server code again
-      serverCode=getServerCode(docHomeServer);
-    }
+   
     
-    //make sure user have file lock grant(local metacat means have it too)
-    //if (getDataFileLockGrant(accnum))
-    //{
-      //register data file into xml_documents table
-      registerDocumentInReplication(docname, doctype, accnum, user, serverCode);
-      //write inputstream into file system.
-      File dataDirectory = new File(filePath);
-      File newFile = new File(dataDirectory, accnum); 
+    // If server is not int the xml replication talbe, insert it into 
+    // xml_replication table
+    //serverList.addToServerListIfItIsNot(docHomeServer);
+    insertServerIntoReplicationTable(docHomeServer);
+    
+    // Get server code again
+    serverCode = getServerCode(docHomeServer);
+    
+    
+    //register data file into xml_documents table
+    registerDocumentInReplication(docname, doctype, accnum, user, serverCode);
+    //write inputstream into file system.
+    File dataDirectory = new File(filePath);
+    File newFile = new File(dataDirectory, accnum); 
        
-      // create a buffered byte output stream
-      // that uses a default-sized output buffer
-      FileOutputStream fos = new FileOutputStream(newFile);
-      BufferedOutputStream outPut = new BufferedOutputStream(fos);
+    // create a buffered byte output stream
+    // that uses a default-sized output buffer
+    FileOutputStream fos = new FileOutputStream(newFile);
+    BufferedOutputStream outPut = new BufferedOutputStream(fos);
 
-      BufferedInputStream bis = null;
-      bis = new BufferedInputStream(input);
-      byte[] buf = new byte[4 * 1024]; // 4K buffer
-      int b = bis.read(buf);
+    BufferedInputStream bis = null;
+    bis = new BufferedInputStream(input);
+    byte[] buf = new byte[4 * 1024]; // 4K buffer
+    int b = bis.read(buf);
        
-      while (b != -1) 
-      {
+    while (b != -1) 
+    {
         outPut.write(buf, 0, b);
         b = bis.read(buf);
-      }
-      bis.close();
-	    outPut.close();
-	    fos.close();
-    
-    //}//if
+    }
+    bis.close();
+	  outPut.close();
+	  fos.close();
+      
+    // Force replicate data file
+    ForceReplicationHandler forceReplication = new ForceReplicationHandler
+                                    (accnum, false, notificationServer);
+  
  }
   
 
@@ -579,7 +597,7 @@
       //saying that he/she needs to download a new copy of the file and
       //merge the differences manually.
       
-      String server = MetacatReplication.getServer(serverCode);
+      String server=MetacatReplication.getServerNameForServerCode(serverCode);
       MetacatReplication.replLog("attempting to lock " + accnum);
       URL u = new URL("https://" + server + "?server=" +
         MetaCatUtil.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
@@ -967,8 +985,12 @@
                             "the latest revision number.");
         }
       }
-      throw new Exception("the requested docid '" + docid.toString() + 
-                        "' does not exist");
+      // Get miss docid and rev, throw to McdDocNotFoundException
+      String missDocId = MetaCatUtil.getDocIdFromString(docid.toString());
+      String missRevision = 
+                  MetaCatUtil.getRevisionStringFromString(docid.toString());
+      throw new McdbDocNotFoundException("the requested docid '" + 
+                docid.toString() + "' does not exist", missDocId, missRevision);
     }//try
     finally
     {
@@ -978,7 +1000,7 @@
   }
 
   private void getDocumentInfo(String docid) throws McdbException, 
-                                                    AccessionNumberException
+                                        AccessionNumberException, Exception
   {
     getDocumentInfo(new DocumentIdentifier(docid));
   }
@@ -988,7 +1010,8 @@
    *
    * @param docid the id of the document to look up
    */
-  private void getDocumentInfo(DocumentIdentifier docid) throws McdbException 
+  private void getDocumentInfo(DocumentIdentifier docid) throws McdbException
+                                                          , Exception
   {
     DBConnection dbconn = null;
     int serialNumber = -1;
@@ -1002,19 +1025,21 @@
         table = "xml_revisions";
       }
     }
-    catch(Exception e)
+    // catch a McdbDocNotFoundException throw it
+    catch (McdbDocNotFoundException notFound)
     {
-      System.out.println("error in DocumentImpl.getDocumentInfo: " + 
-                          e.getMessage());
+      throw notFound;
     }
-    
-    //deal with the key words here.
-    
-    if(docid.getRev().equals("all"))
+    catch(Exception e)
     {
       
+      MetaCatUtil.debugMessage("error in DocumentImpl.getDocumentInfo: " + 
+                          e.getMessage(), 30);
+      throw e;
     }
     
+
+    
     try 
     {
       dbconn=DBConnectionPool.getDBConnection("DocumentImpl.getDocumentInfo");
@@ -1124,7 +1149,8 @@
     }
 
     if (this.docname == null) {
-      throw new McdbDocNotFoundException("Document not found: " + docid);
+      throw new McdbDocNotFoundException("Document not found: " + docid,
+                                 docid.getIdentifier(), docid.getRev());
     }
   }
 
@@ -1270,7 +1296,7 @@
 
         // Save the old document publicaccessentry in a backup table
         DocumentImpl.archiveDocRevision(connection, docid, user );
-        DocumentImpl thisdoc = new DocumentImpl(docid);
+        DocumentImpl thisdoc = new DocumentImpl(docid, false);
         int thisrev = thisdoc.getRev();
         
         //if the updated vesion is not greater than current one,
@@ -1474,7 +1500,7 @@
   
       DocumentIdentifier id = new DocumentIdentifier(accnum);
       String updaterev = id.getRev();
-      String server = MetacatReplication.getServer(serverCode);
+      String server=MetacatReplication.getServerNameForServerCode(serverCode);
       MetacatReplication.replLog("attempting to lock " + accnum);
       URL u = new URL("https://" + server + "?server="+
         MetaCatUtil.getLocalReplicationServerName()+"&action=getlock&updaterev=" 
@@ -1505,22 +1531,11 @@
                 
         
         
-        //If Metacat is super hub, tell all servers in its server list to get 
-        //the new document, ture mean it is xml document
-        if ((MetaCatUtil.getOption("hub")).equals("super"))
-        {
-          ForceReplicationHandler frh = new ForceReplicationHandler(accnum, 
-                true, ReplicationHandler.buildServerList());
-        }
-        else
-        {
-          //after inserting the document locally, tell the document's homeserver
-          //to come get a copy from here.
-         
-          ForceReplicationHandler frh = new ForceReplicationHandler(accnum, 
-                true, ReplicationHandler.getHomeServer(docid));
-        }
-        return (accnum);
+        // Force replication the docid
+        ForceReplicationHandler frh = new ForceReplicationHandler
+                                                          (accnum, true, null);
+        return(accnum);
+   
       }
 
       else if(openingtag.equals("<filelocked>"))
@@ -1574,16 +1589,14 @@
       throw e;
     }
     
-    //force replicate out the new document to each server in our server list.
-    if(serverCode == 1)
-    { 
+    // Force replicate out the new document to each server in our server list.
+    // Start the thread to replicate this new document out to the other servers
+    // true mean it is xml document
+    // null is because no metacat notify the force replication.
+    ForceReplicationHandler frh = new ForceReplicationHandler
+                                                  (accnum, action, true, null);
       
-      //start the thread to replicate this new document out to the other servers
-      //true mean it is xml document
-      ForceReplicationHandler frh = new ForceReplicationHandler
-                (accnum, action, true,ReplicationHandler.buildServerList());
-      
-    }
+   
     MetaCatUtil.debugMessage("Conn Usage count after writting: "
                                                       +conn.getUsageCount(),50); 
     return(accnum);
@@ -1602,41 +1615,74 @@
    * @param groups the groups to which user belongs
    * @param homeServer the name of server which the document origanlly create
    * @param validate, if the xml document is valid or not
+   * @param notifyServer, the server which notify local server the force 
+   *                       replication command
    */
 
   public static String writeReplication(DBConnection conn, Reader xml, 
             String pub, Reader dtd, String action, String accnum, String user,
-            String[] groups,String homeServer, boolean validate)
+     String[] groups,String homeServer, boolean validate, String notifyServer)
                 throws Exception
   {
+    // Docid without revision
+    String docid=MetaCatUtil.getDocIdFromString(accnum);
+    // Revision specified by user (int)
+    int userSpecifyRev=MetaCatUtil.getVersionFromString(accnum);
+    // Revision for this docid in current database
+    int revInDataBase=getLatestRevisionNumber(docid);
+    // String to store the revision
+    String rev = null;
    
-    String docid=MetaCatUtil.getDocIdFromString(accnum);
-    String rev=(new Integer(MetaCatUtil.getVersionFromString(accnum))).
-                                                                    toString();
     
-    //check if xml_documents table has the document or not
-    //if not, set action to insert
-    if (getLatestRevisionNumber(docid)==-1)
+    //revIndataBase=-1, there is no record in xml_documents table
+    //the document is a new one for local server, inert it into table
+    //user specified rev should be great than 0
+    if (revInDataBase==-1 && userSpecifyRev>0 )
     {
-      action="INSERT";
+        // rev equals user specified
+        rev=(new Integer(userSpecifyRev)).toString();
+        // action should be INSERT
+        action = "INSERT";
     }
-    
-    int serverCode=-2;
-    //get server code for the home server
-    serverCode=getServerCode(homeServer);
-    //if the server is not in the xml replication table, insert it.
-    if (serverCode==-1)
+    //rev is greater the last revsion number and revInDataBase isn't -1
+    // it is a updated  file
+    else if (userSpecifyRev>revInDataBase && revInDataBase>0)
     {
-      insertServerIntoReplicationTable(homeServer);
-      //get server code again
-      serverCode=getServerCode(homeServer);
+       // rev equals user specified
+       rev=(new Integer(userSpecifyRev)).toString();
+       // action should be update
+       action = "UPDATE";
     }
-      
-    MetaCatUtil.debugMessage("action: " + action + " servercode: " + 
-                             serverCode, 10);
+    // local server has newer version, then notify the remote server
+    else if ( userSpecifyRev < revInDataBase && revInDataBase > 0)
+    {
+      throw new Exception("Local server: "+MetaCatUtil.getOption("server")+
+                " has newer revision of doc: "+docid+"."+revInDataBase
+                 +". Please notify it.");
+    }
+    //other situation
+    else
+    {
+        
+        throw new Exception("The docid"+docid+"'s revision number couldn't be "
+                    +userSpecifyRev);
+    }
+    // Variable to store homeserver code
+    int serverCode=-2;
+    
+     // If server is not int the xml replication talbe, insert it into
+    // xml_replication table
+    //serverList.addToServerListIfItIsNot(homeServer);
+    insertServerIntoReplicationTable(homeServer);
+    // Get server code again
+    serverCode = getServerCode(homeServer);
+    
+    
+    MetaCatUtil.debugMessage("Document "+docid+"."+rev+" "+action+ " into local"
+                               +" metacat with servercode: "+ serverCode, 10);
                         
   
-
+    // insert into xml_nodes and xml_index table
     try 
     { 
       
@@ -1653,6 +1699,11 @@
       conn.setAutoCommit(true);
       throw e;
     }
+    
+    //Force replication to other server
+    ForceReplicationHandler forceReplication = new ForceReplicationHandler
+                                  (accnum, action, true, notifyServer);
+    
 
     return(accnum);
   }
@@ -2220,28 +2271,54 @@
    * Insert a server into xml_replcation table
    * @param server, the name of server 
    */
-  private static void  insertServerIntoReplicationTable(String server)
+  private static synchronized void 
+                                insertServerIntoReplicationTable(String server)
   {
     PreparedStatement pStmt=null;
     DBConnection dbConn = null;
     int serialNumber = -1;
-    int replicate = 1;
-    //MetaCatUtil util = new MetaCatUtil();
+    
+    // Initial value for the server
+    int replicate = 0;
+    int dataReplicate = 0;
+    int hub = 0;
+   
     try
     {
-       //dbConn=util.openDBConnection();
-       //check out DBConnection
+       // Get DBConnection
        dbConn=DBConnectionPool.
                 getDBConnection("DocumentImpl.insertServIntoReplicationTable");
        serialNumber=dbConn.getCheckOutSerialNumber();
-       pStmt = dbConn.prepareStatement("INSERT INTO xml_replication " +
-                                      "(server, last_checked, replicate) " +
-                                      "VALUES ('" + server + "', to_date(" +
-                                      "'01/01/00', 'MM/DD/YY'), '" +
-                                      replicate + "')");
+      
+      // Compare the server to dabase
+      pStmt = dbConn.prepareStatement
+      ("SELECT serverid FROM xml_replication WHERE server='" + server +"'");
+      pStmt.execute();
+      ResultSet rs = pStmt.getResultSet();
+      boolean hasRow = rs.next();
+      // Close preparedstatement and result set
+      pStmt.close();
+      rs.close();
+      
+      // If the server is not in the table, and server is not local host,
+      // insert it
+      if ( !hasRow 
+         && !server.equals(MetaCatUtil.getLocalReplicationServerName()))
+      {
+        // Set auto commit false
+        dbConn.setAutoCommit(false);
+        pStmt = dbConn.prepareStatement("INSERT INTO xml_replication " +
+                      "(server, last_checked, replicate, datareplicate, hub) " +
+                       "VALUES ('" + server + "', to_date(" +
+                       "'01/01/00', 'MM/DD/YY'), '" +
+                       replicate +"', '"+dataReplicate+"','"+ hub + "')");
         pStmt.execute();
+        dbConn.commit();
+        // Increase usage number
+        dbConn.increaseUsageCount(1);
         pStmt.close();
-        dbConn.commit();
+        
+      }
     }//try
     catch (Exception e)
     {
@@ -2253,7 +2330,10 @@
      
       try
       {
+        // Set auto commit true
+        dbConn.setAutoCommit(true);
         pStmt.close();
+        
       }//try
       catch (Exception ee)
       {
